package upnp

import (
	"testing"

	omd "git.loafle.net/overflow/model/discovery"
	omm "git.loafle.net/overflow/model/meta"
	"git.loafle.net/overflow_scanner/probe/discovery/session"
	"git.loafle.net/overflow_scanner/probe/discovery/types"
)

func TestScan(t *testing.T) {
	s := session.NewMockDiscoverySession(
		"testRequester",
		types.DiscoveryRequestTypeHost,
		&omd.Zone{
			Network:    "192.168.1.0/24",
			Iface:      "enp3s0",
			MetaIPType: omm.ToMetaIPType(omm.MetaIPTypeEnumV4),
			Address:    "192.168.1.101",
			Mac:        "44:8a:5b:f1:f1:f3",
		},
		&omd.DiscoverHost{
			MetaIPType:      omm.ToMetaIPType(omm.MetaIPTypeEnumV4),
			FirstScanRange:  "192.168.1.1",
			LastScanRange:   "192.168.1.254",
			DiscoveryConfig: &omd.DiscoveryConfig{},
		},
	)

	type args struct {
		discoverySession session.DiscoverySession
	}
	tests := []struct {
		name    string
		args    args
		wantErr bool
	}{
		{
			name: "1",
			args: args{
				discoverySession: s,
			},
			wantErr: false,
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			if err := Scan(tt.args.discoverySession); (err != nil) != tt.wantErr {
				t.Errorf("Scan() error = %v, wantErr %v", err, tt.wantErr)
			}
		})
	}
}
